var mainCtrl = function($scope, $timeout) {
  $scope.applyButtonName = null;
  $scope.previewShowAfter = null;
  $scope.existsBeforeImg = false;
  $scope.existsAfterImg = false;
  $scope.filePostFix = null;
  $scope.debug = null;
  
  $scope.whitebalance = {};
  $scope.falloff = {};
  $scope.apdiffrac = {};
  $scope.reinhard = {};
  $scope.gamma = {};
  
  // 初期化
  $scope.init = function() {
    $scope.applyButtonName ="プレビュー更新";
    $scope.previewShowAfter = true;
    $scope.isError = false;
    
    // 子パネルの準備が整っていなかったら0.1秒後にリトライする
    // isErrorを確認すればパネルの初期化が完了していることを保証するため，isErrorはパネル初期化の最後に追加すること．
    $timeout(function(){
      if ("isError" in $scope.whitebalance &&
          "isError" in $scope.falloff &&
          "isError" in $scope.apdiffrac &&
          "isError" in $scope.reinhard &&
          "isError" in $scope.gamma) {
        $scope.createBeforeImg();
        $scope.createAfterImg();
        $scope.filePostFix = "?" + (new Date()).getTime();
        $scope.existsBeforeImg = true;
        $scope.existsAfterImg = true;
      } else {
        $scope.init();
      }
    }, 100);
  };
  
  // 入力がtrueなら"enable"，falseなら"disable"を返す
  $scope.isEnable = function(isActive) {
    if (isActive) {return "enable";}
    else {return "disable";}
  };
  
  // 入力値に不正な値がないか巡回する
  $scope.update = function() {
    if ($scope.whitebalance.isError ||
        $scope.falloff.isError ||
        $scope.apdiffrac.isError ||
        $scope.reinhard.isError ||
        $scope.gamma.isError) {
      $scope.isError = true;
    } else {
      $scope.isError = false;
    }
  };
  
  // Widgetのindex.htmlのあるディレクトリのフルパスを返す
  // ex: C:/Users/xxxx/Documents/
  $scope.getFilePath = function() {
    var dir = location.href;
    
    // URIスキームを取り除く
    var pos = dir.indexOf("://");
    if (pos > 0) {dir = dir.substr(pos + 4);}
    
    // ファイル名を取り除く
    var pos = dir.lastIndexOf("/");
    if (pos >= 0) {dir = dir.substr(0, pos + 1);}
    
    return dir;
  };
  
  // ブラウザがIEか判定
  $scope.isIE = function() {
    var userAgent = window.navigator.userAgent.toLowerCase();
    if (userAgent.indexOf("msie") != -1) {return true;}  // IE10まで
    else if (userAgent.indexOf("trident/7") != -1) {return true;}  // IE11
    else {return false;}
  };
  
  // 外部テキストを読み込む
  $scope.readFileToString = function(fileName) {
    var xmlHttp;
    if ($scope.isIE()) {
      xmlHttp = new ActiveXObject("Msxml2.XMLHTTP");
    } else if (window.XMLHttpRequest) {
      xmlHttp = new XMLHttpRequest();
    } else {
      xmlHttp = null;
    }
    if (xmlHttp == null) return "";
    
    var str = "";
    try {
      xmlHttp.open("GET", fileName, false);
      xmlHttp.send(null);
      str = xmlHttp.responseText;
    } catch(e) {
      window.alert(e);
    }
    return str;
  }
  
  // 処理前サムネイルのリフレッシュ
  $scope.createBeforeImg = function() {
    dir = $scope.getFilePath();
    py_src = $scope.readFileToString("./createBeforeImg.py").replace(/\[\[CURRENT_DIR\]\]/g, dir);
    window.external.setScript(py_src);
    return;
  };
  
  // 処理後サムネイルのリフレッシュ
  $scope.createAfterImg = function() {
    dir = $scope.getFilePath();
    py_src = $scope.readFileToString("./createAfterImg.py").replace(/\[\[CURRENT_DIR\]\]/g, dir);
    
    // レンダリング結果に適用オプション
    if ($scope.applyButtonName == "レンダリング結果に適用") {py_src = py_src.replace(/\[\[APPLY_RENDERING_IMAGE\]\]/g, "True");}
    else {py_src = py_src.replace(/\[\[APPLY_RENDERING_IMAGE\]\]/g, "False");}
    
    // ホワイトバランスのパラメータ
    if ($scope.whitebalance.isActive) {py_src = py_src.replace(/\[\[WHITEBALANCE\.IS_ACTIVE\]\]/g, "True");}
    else {py_src = py_src.replace(/\[\[WHITEBALANCE\.IS_ACTIVE\]\]/g, "False");}
    py_src = py_src.replace(/\[\[WHITEBALANCE\.T\]\]/g, $scope.whitebalance.T.toString());
    
    // 光量落ちのパラメータ
    if ($scope.falloff.isActive) {py_src = py_src.replace(/\[\[FALLOFF\.IS_ACTIVE\]\]/g, "True");}
    else {py_src = py_src.replace(/\[\[FALLOFF\.IS_ACTIVE\]\]/g, "False");}
    
    // 回折のパラメータ
    if ($scope.apdiffrac.isActive) {py_src = py_src.replace(/\[\[APDIFFRAC\.IS_ACTIVE\]\]/g, "True");}
    else {py_src = py_src.replace(/\[\[APDIFFRAC\.IS_ACTIVE\]\]/g, "False");}
    py_src = py_src.replace(/\[\[APDIFFRAC\.F\]\]/g, $scope.apdiffrac.F.toString());
    
    // トーンマッピングのパラメータ
    if ($scope.reinhard.isActive) {py_src = py_src.replace(/\[\[REINHARD\.IS_ACTIVE\]\]/g, "True");}
    else {py_src = py_src.replace(/\[\[REINHARD\.IS_ACTIVE\]\]/g, "False");}
    py_src = py_src.replace(/\[\[REINHARD\.A\]\]/g, $scope.reinhard.a.toString());
    py_src = py_src.replace(/\[\[REINHARD\.LW\]\]/g, $scope.reinhard.Lw.toString());
    
    // ガンマ補正のパラメータ
    if ($scope.gamma.isActive) {py_src = py_src.replace(/\[\[GAMMA\.IS_ACTIVE\]\]/g, "True");}
    else {py_src = py_src.replace(/\[\[GAMMA\.IS_ACTIVE\]\]/g, "False");}
    py_src = py_src.replace(/\[\[GAMMA\.GAMMA\]\]/g, "2.2");
    
    window.external.setScript(py_src);
    return;
  };
  
  // 適用
  $scope.apply = function() {
    $scope.createBeforeImg();
    $scope.createAfterImg();
    $scope.filePostFix = "?" + (new Date()).getTime();
    return;
  };
};

var whitebalanceCtrl = function($scope) {
  $scope.whitebalance.init = function() {
    $scope.whitebalance.isActive = false;
    $scope.whitebalance.T = 5200;
    $scope.whitebalance.isError = false;
    return;
  };
  
  $scope.whitebalance.update = function() {
    if ($scope.whitebalance.T) {$scope.reinhard.isError = false;}
    else {$scope.whitebalance.isError = true;}
    $scope.update();
    return;
  };
};

var falloffCtrl = function($scope) {
  $scope.falloff.init = function() {
    $scope.falloff.isActive = false;
    $scope.falloff.isError = false;
    return;
  };
  
  $scope.falloff.update = function() {
    $scope.update();
    return;
  };
};

var apdiffracCtrl = function($scope) {
  $scope.apdiffrac.init = function() {
    $scope.apdiffrac.isActive = false;
    $scope.apdiffrac.F = 8.0;
    $scope.apdiffrac.isError = false;
    return;
  };
  
  $scope.apdiffrac.update = function() {
    if ($scope.apdiffrac.F) {$scope.apdiffrac.isError = false;}
    else {$scope.apdiffrac.isError = true;}
    $scope.update();
    return;
  };
};

var reinhardCtrl = function($scope) {
  $scope.reinhard.init = function() {
    $scope.reinhard.isActive = true;
    $scope.reinhard.a = 0.18;
    $scope.reinhard.Lw = 3.0;
    $scope.reinhard.isError = false;
    return;
  };
  
  $scope.reinhard.update = function() {
    if ($scope.reinhard.a && $scope.reinhard.Lw) {$scope.reinhard.isError = false;}
    else {$scope.reinhard.isError = true;}
    $scope.update();
    return;
  };
};

var gammaCtrl = function($scope) {
  $scope.gamma.init = function() {
    $scope.gamma.isActive = true;
    $scope.gamma.gamma = 2.2;
    $scope.gamma.isError = false;
    return;
  };
  
  $scope.gamma.update = function() {
    $scope.update();
    return;
  };
};
